<?php
/*
Plugin Name: İç Link Yöneticisi
Plugin URI: https://www.seogle.com.tr/wordpress-eklentilerimiz/
Description: Belirtilen kategoriler içerik içinde geçiyorsa en fazla 4 tane belirtilen url'ye link verir.
Version: 1.0
Author: Okan CERİT
Author URI: https://www.linkedin.com/in/okancerit/
License: GPL2
*/

// Eklenti Yüklenirken Gereken Dosyalar
include('admin/dashboard.php');
wp_enqueue_script('jquery');

// Eklenti Etkinleştirildiğinde Çalıştırılacak Fonksiyonlar
function klm_activate() {
    global $wpdb;
    $table_name = $wpdb->prefix . "klm_keywords";
    $charset_collate = $wpdb->get_charset_collate();

    $sql = "CREATE TABLE $table_name (
        id mediumint(9) NOT NULL AUTO_INCREMENT,
        keyword varchar(255) NOT NULL,
        url varchar(255) NOT NULL,
        PRIMARY KEY  (id)
    ) $charset_collate;";

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
}
register_activation_hook(__FILE__, 'klm_activate');

// Eklenti Devre Dışı Bırakıldığında Çalıştırılacak Fonksiyonlar
function klm_deactivate() {
    global $wpdb;
    $table_name = $wpdb->prefix . "klm_keywords";
    $sql = "DROP TABLE IF EXISTS $table_name;";
    $wpdb->query($sql);
}
register_deactivation_hook(__FILE__, 'klm_deactivate');

// İçerik Filtresi Ekleme
add_filter('the_content', 'klm_add_keyword_links');
function klm_add_keyword_links($content) {
    if (is_singular('post')) {
        global $wpdb;
        $table_name = $wpdb->prefix . "klm_keywords";
        $keywords = $wpdb->get_results("SELECT * FROM $table_name");

        // İçerikteki resim etiketlerini koruma
        preg_match_all('/<img[^>]+>/i', $content, $images);
        $image_placeholders = array();
        foreach ($images[0] as $index => $img) {
            $placeholder = '[IMAGE-' . $index . ']';
            $content = str_replace($img, $placeholder, $content);
            $image_placeholders[$placeholder] = $img;
        }

        // Anahtar kelimelerin eklenmesi
        foreach ($keywords as $keyword) {
            $count = 0;
            $pattern = '/\b' . preg_quote($keyword->keyword, '/') . '\b/i';
            $replacement = function($matches) use ($keyword, &$count) {
                if ($count < 4) {
                    $count++;
                    return '<a href="' . esc_url($keyword->url) . '">' . $matches[0] . '</a>';
                } else {
                    return $matches[0];
                }
            };

            // Önceki anahtar kelime linklerini kaldır
            $content = preg_replace('/<a\s+href=["\'][^"\']*["\'][^>]*>(.*?)<\/a>/i', '$1', $content);

            // Anahtar kelimeleri sadece paragraflarda ekle
            $content = preg_replace_callback('/<p\b[^>]*>(.*?)<\/p>/i', function($matches) use ($pattern, $replacement) {
                return preg_replace_callback($pattern, $replacement, $matches[0]);
            }, $content);
        }

        // Resim etiketlerini geri yükleme
        foreach ($image_placeholders as $placeholder => $img) {
            $content = str_replace($placeholder, $img, $content);
        }

        // Başlık etiketlerini muaf tutma
        $content = preg_replace_callback('/<(h[1-6])[^>]*>(.*?)<\/\\1>/i', function($matches) {
            return $matches[0]; // Başlık etiketlerini olduğu gibi muaf tut
        }, $content);
    }

    return $content;
}
?>
